﻿Type=StaticCode
Version=3.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module

Sub Process_Globals
	Private fx As JFX
	Private start As String
	Private fin As String
	Private bs As String
	Private bcolor As Int
	Private fcolor As Int
	Dim su As StringUtilities
    Private fore_color As Paint
	Private back_color As Paint
	Private barwidth As Int
	
End Sub

'Description: Generates Code11 barcodes
'
'Method of calling:
'Private fx As JFX (this should be declared in Sub Process_Globals of the main module)
'message = "40156" 
'start_chr = "A"
'stop_chr = "B"
'front_color = fx.Colors.Blue
'back_color = fx.Colors.Yellow
'bar_width = 3
'Private Canvas1 as Canvas
'Canvas1 = Code11.Draw_Code11(message, start_chr, stop_chr, front_color, back_color, bar_width, Canvas1)
'
'where 'message' = message to be encoded - type String
'where 'start_chr' = start character (A, B, C, or D) - type String
'where 'stop_chr' = stop character (A, B, C, or D) - type String
'where 'front_color' = background color of the code - type Paint
'where 'back_color' = foreground color of the code (solid bar color) - type Paint
'where 'bar_width' = the bar width of the front_color (1) and back_color (0) bars - type Int
Public Sub Draw_Code11 (message As String, strt As String, stp As String, fc As Paint, bc As Paint, bw As Int, c As Canvas) As Canvas

barwidth = bw
fore_color = fc
back_color = bc
Dim flag As Int
su.Initialize

Dim karak, new_mes As String

If strt = "a" Then strt = "A"
If strt = "b" Then strt = "B"
If strt = "c" Then strt = "C"
If strt = "d" Then strt = "D"

If stp = "a" Then stp = "A"
If stp = "b" Then stp = "B"
If stp = "c" Then stp = "C"
If stp = "d" Then stp = "D"

new_mes = ""
flag = 0

For i = 1 To su.stringLength(message)

    karak = su.Mid(message,i,1)
	If karak <> "0" And karak <> "1" And karak <> "2" And _
	   karak <> "3" And karak <> "4" And karak <> "5" And _
	   karak <> "6" And karak <> "7" And karak <> "8" And _
	   karak <> "9" And karak <> "-" And karak <> "$" And _
	   karak <> ":" And karak <> "." And karak <> "/" And _
	   karak <> "+" Then
	   flag = 1
	   Exit
    End If
	new_mes = new_mes & karak
Next	

message = new_mes

If flag = 0 Then
build_string(message,strt,stp,c)
End If

If flag = 1 Then
'  ToastMessageShow ("You are attempting to encode invalid Code11 characters", False)
End If
   
Return c
 
End Sub


Private Sub build_string(message As String, begin As String, einde As String, d As Canvas) As Canvas

Dim karak As String
bs = ""
If begin = "A" Then start = "1011001001"
If begin = "B" Then start = "1010010011"
If begin = "C" Then start = "1001001011"
If begin = "D" Then start = "1010011001"

	 
bs = bs & start
bs = bs & "0"

For i = 1 To su.stringLength(message)
    karak = su.Mid(message,i,1)
	If karak = "0" Then bs = bs & "101010011"
	If karak = "1" Then bs = bs & "101011001"
	If karak = "2" Then bs = bs & "101001011"
	If karak = "3" Then bs = bs & "110010101"
	If karak = "4" Then bs = bs & "101101001"
	If karak = "5" Then bs = bs & "110101001"
	If karak = "6" Then bs = bs & "100101011"
	If karak = "7" Then bs = bs & "100101101"
	If karak = "8" Then bs = bs & "100110101"
	If karak = "9" Then bs = bs & "110100101"
	If karak = "-" Then bs = bs & "101001101"
	If karak = "$" Then bs = bs & "101100101"
	If karak = ":" Then bs = bs & "1101011011"
	If karak = "/" Then bs = bs & "1101101011"
	If karak = "." Then bs = bs & "1101101101"
	If karak = "+" Then bs = bs & "101100110011"
	bs = bs & "0" 
Next	

If einde = "A" Then fin = "1011001001"
If einde = "B" Then fin = "1010010011"
If einde = "C" Then fin = "1001001011"
If einde = "D" Then fin = "1010011001"	 

bs = bs & fin

draw_barcode_Code11(bs,d)
Return d

End Sub

Sub draw_barcode_Code11 (mes As String, e As Canvas) As Canvas

    Dim cnt As Int = 1
	For i = 1 To su.stringLength(mes) 
	  If su.Mid(mes,i,1) = "1" Then
	    e.DrawRect(cnt,10,barwidth,80,fore_color,True,2)
	  Else
	    e.DrawRect(cnt,10,barwidth,80,back_color,True,2)
	End If  	
	  cnt = cnt + barwidth
	Next  
	
	Return e 

End Sub



