﻿Type=StaticCode
Version=3.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private start As String
	Private fin As String
	Private su As StringUtilities
	Private bs As String
    Private fore_color As Paint
	Private back_color As Paint
	Private barwidth As Int		
End Sub


'Description: Generates Code93 barcodes
'
'Method of calling:
'Private fx As JFX (this should be declared in Sub Process_Globals of the main module)
'message = "40156" 
'front_color = fx.Colors.Blue
'back_color = fx.Colors.Yellow
'bar_width = 3
'Private Canvas1 as Canvas
'Canvas1 = Code93.Draw_Code93(message, front_color, back_color, bar_width, Canvas1)
'
'where 'message' = message to be encoded - type String
'where 'front_color' = background color of the code - type Paint
'where 'back_color' = foreground color of the code (solid bar color) - type Paint
'where 'bar_width' = the bar width of the front_color (1) and back_color (0) bars - type Int
Public Sub Draw_Code93 (message As String, fc As Paint, bc As Paint, bw As Int, c As Canvas) As Canvas

barwidth = bw
fore_color = fc
back_color = bc
Dim flag As Int
su.Initialize()
Dim karak, new_mes As String



new_mes = ""
flag = 0
For i = 1 To su.stringLength(message)
    karak = su.Mid(message,i,1)
	If karak = "a" Then karak = "A"
	If karak = "b" Then karak = "B"
    If karak = "c" Then karak = "C"
	If karak = "d" Then karak = "D"
	If karak = "e" Then karak = "E"
	If karak = "f" Then karak = "F"
	If karak = "g" Then karak = "G"
	If karak = "h" Then karak = "H"
	If karak = "i" Then karak = "I"
	If karak = "j" Then karak = "J"
	If karak = "k" Then karak = "K"
	If karak = "l" Then karak = "L"
	If karak = "m" Then karak = "M"
	If karak = "n" Then karak = "N"
	If karak = "o" Then karak = "O"
	If karak = "p" Then karak = "P"
	If karak = "q" Then karak = "Q"
	If karak = "r" Then karak = "R"
	If karak = "s" Then karak = "S"
	If karak = "t" Then karak = "T"
	If karak = "u" Then karak = "U"
	If karak = "v" Then karak = "V"
	If karak = "w" Then karak = "W"
	If karak = "x" Then karak = "X"
	If karak = "y" Then karak = "Y"
	If karak = "z" Then karak = "Z"
	If karak <> "0" And karak <> "1" And karak <> "2" And _
	   karak <> "3" And karak <> "4" And karak <> "5" And _
	   karak <> "6" And karak <> "7" And karak <> "8" And _
	   karak <> "9" And karak <> "A" And karak <> "B" And _
	   karak <> "C" And karak <> "D" And karak <> "E" And _
	   karak <> "F" And karak <> "G" And karak <> "H" And _
	   karak <> "I" And karak <> "J" And karak <> "K" And _
	   karak <> "L" And karak <> "M" And karak <> "N" And _
	   karak <> "O" And karak <> "P" And karak <> "Q" And _
	   karak <> "R" And karak <> "S" And karak <> "T" And _
	   karak <> "U" And karak <> "V" And karak <> "W" And _
	   karak <> "X" And karak <> "Y" And karak <> "Z" And _
	   karak <> "-" And karak <> "." And karak <> " " And _
	   karak <> "$" And karak <> "/" And karak <> "+" And _
	   karak <> "%" Then
	   flag = 1
	   Exit
    End If
	new_mes = new_mes & karak
Next	

message = new_mes
'Log (message)
If flag = 0 Then
  build_string(message, c)
End If

If flag = 1 Then
'  ToastMessageShow ("You are attempting to encode invalid Code93 characters", False)
End If
   
Return c
 
End Sub


Private Sub build_string(message As String, d As Canvas) As Canvas

Dim karak As String
Dim first_check As Int
Dim second_check,teller As Int

first_check = 0
second_check = 0

Dim var() As String
var = Array As String("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","-","."," ","$","/","+","%")

teller = 1
For i = su.stringLength(message) To 1 Step -1
   For j=0 To 42
     If su.Mid(message,i,1) = var(j) Then
       first_check = first_check + (j * teller)
       teller = teller + 1
     End If	
   Next	 
Next

first_check = first_check Mod 47
message = message & var(first_check)

teller = 1
For i = su.stringLength(message)  To 1 Step -1
   For j=0 To 42
     If su.Mid(message,i,1) = var(j) Then
       second_check = second_check + (j * teller)
       teller = teller + 1
     End If	
   Next	 
Next

second_check = second_check Mod 47
message = message & var(second_check)

'Log(first_check)
'Log(second_check)


bs = ""
start = "101011110"	
bs = bs & start

For i = 1 To su.stringLength(message) 
    karak = su.Mid(message,i,1)
	If karak = "0" Then bs = bs & "100010100"
	If karak = "1" Then bs = bs & "101001000"
	If karak = "2" Then bs = bs & "101000100"
	If karak = "3" Then bs = bs & "101000010"
	If karak = "4" Then bs = bs & "100101000"
	If karak = "5" Then bs = bs & "100100100"
	If karak = "6" Then bs = bs & "100100010"
	If karak = "7" Then bs = bs & "101010000"
	If karak = "8" Then bs = bs & "100010010"
	If karak = "9" Then bs = bs & "100001010"
	If karak = "A" Then bs = bs & "110101000"
	If karak = "B" Then bs = bs & "110100100"
	If karak = "C" Then bs = bs & "110100010"
	If karak = "D" Then bs = bs & "110010100"
	If karak = "E" Then bs = bs & "110010010"
	If karak = "F" Then bs = bs & "110001010"
	If karak = "G" Then bs = bs & "101101000"
	If karak = "H" Then bs = bs & "101100100"
	If karak = "I" Then bs = bs & "101100010"
	If karak = "J" Then bs = bs & "100110100"
	If karak = "K" Then bs = bs & "100011010"
	If karak = "L" Then bs = bs & "101011000"
	If karak = "M" Then bs = bs & "101001100"
	If karak = "N" Then bs = bs & "101000110"
	If karak = "O" Then bs = bs & "100101100"
	If karak = "P" Then bs = bs & "100010110"
	If karak = "Q" Then bs = bs & "110110100"
	If karak = "R" Then bs = bs & "110110010"
	If karak = "S" Then bs = bs & "110101100"
	If karak = "T" Then bs = bs & "110100110"
	If karak = "U" Then bs = bs & "110010110"
	If karak = "V" Then bs = bs & "110011010"
	If karak = "W" Then bs = bs & "101101100"
	If karak = "X" Then bs = bs & "101100110"
	If karak = "Y" Then bs = bs & "100110110"
	If karak = "Z" Then bs = bs & "100111010"
	If karak = "-" Then bs = bs & "100101110"
	If karak = "." Then bs = bs & "111010100"
	If karak = " " Then bs = bs & "111010010"
	If karak = "$" Then bs = bs & "111001010"
	If karak = "/" Then bs = bs & "101101110"
	If karak = "+" Then bs = bs & "101110110"
	If karak = "%" Then bs = bs & "110101110"
Next	

fin = "101011110"	
bs = bs & fin
bs = bs & "1"

draw_barcode_Code93 (bs, d )
Return d

End Sub

Sub draw_barcode_Code93 (mes As String, e As Canvas) As Canvas

    Dim cnt As Int = 1
	For i = 1 To su.stringLength(mes) 
	  If su.Mid(mes,i,1) = "1" Then
	    e.DrawRect(cnt,10,barwidth,80,fore_color,True,2)
	  Else
	    e.DrawRect(cnt,10,barwidth,80,back_color,True,2)
	End If  	
	  cnt = cnt + barwidth
	Next  
	
	Return e 

End Sub



